"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var ContentText = (0, react_1.forwardRef)(function (_a, ref) {
    var className = _a.className, editable = _a.editable, style = _a.style, contentText = _a.contentText, isOverflow = _a.isOverflow, onUpdateText = _a.onUpdateText;
    var _b = (0, react_1.useState)(""), htmlText = _b[0], setHtmlText = _b[1];
    (0, react_1.useEffect)(function () {
        setHtmlText(contentText);
    }, [contentText]);
    var textClassName = (0, react_1.useMemo)(function () {
        var cn = [];
        if (!editable) {
            cn.push("no-drag");
        }
        if (className) {
            cn.push(className);
        }
        return cn.join(" ");
    }, [editable, className]);
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(StyledWarningBox, { className: !isOverflow ? "hide" : "" }), (0, jsx_runtime_1.jsx)(StyledText, { className: textClassName, style: __assign({}, style), ref: ref, suppressContentEditableWarning: editable, contentEditable: editable, dangerouslySetInnerHTML: { __html: htmlText }, onKeyDown: function (e) {
                    if (e.key === "Enter") {
                        e.preventDefault(); //Prevent default browser behavior
                        if (window.getSelection) {
                            var selection = window.getSelection();
                            if (!selection) {
                                return;
                            }
                            var range = selection.getRangeAt(0);
                            if (!range) {
                                return;
                            }
                            var br = document.createElement("br");
                            var textNode = document.createTextNode("\u00a0"); //Passing " " directly will not end up being shown correctly
                            range.deleteContents(); //required or not?
                            range.insertNode(br);
                            range.collapse(false);
                            range.insertNode(textNode);
                            range.selectNodeContents(textNode);
                            selection.removeAllRanges();
                            selection.addRange(range);
                            return false;
                        }
                    }
                }, onBlur: function (e) { return onUpdateText(e.currentTarget.innerHTML); } })] }));
});
exports.default = (0, react_1.memo)(ContentText);
var StyledWarningBox = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: block;\n  width: 746px;\n  height: 746px;\n  position: absolute;\n  top: -3px;\n  left: -3px;\n  border: 3px solid red;\n  &.hide {\n    display: none;\n  }\n"], ["\n  display: block;\n  width: 746px;\n  height: 746px;\n  position: absolute;\n  top: -3px;\n  left: -3px;\n  border: 3px solid red;\n  &.hide {\n    display: none;\n  }\n"])));
var StyledText = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 740px;\n  height: 740px;\n  margin: 0 auto;\n  box-sizing: border-box;\n  border: 1px solid #333;\n  outline: none;\n  caret-color: #333;\n  word-break: break-word;\n  position: relative;\n"], ["\n  width: 740px;\n  height: 740px;\n  margin: 0 auto;\n  box-sizing: border-box;\n  border: 1px solid #333;\n  outline: none;\n  caret-color: #333;\n  word-break: break-word;\n  position: relative;\n"])));
var templateObject_1, templateObject_2;
