"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-nocheck
var react_1 = __importDefault(require("react"));
require("./AlertTemplate.css");
var BaseIcon = function BaseIcon(_ref) {
    var color = _ref.color, _ref$pushRight = _ref.pushRight, pushRight = _ref$pushRight === undefined ? true : _ref$pushRight, children = _ref.children;
    return react_1.default.createElement("svg", {
        xmlns: "http://www.w3.org/2000/svg",
        width: "24",
        height: "24",
        viewBox: "0 0 24 24",
        fill: "none",
        stroke: color,
        strokeWidth: "2",
        strokeLinecap: "round",
        strokeLinejoin: "round",
        style: { marginRight: pushRight ? "20px" : "0", minWidth: 24 },
    }, children);
}; //alert.show
var InfoIcon = function InfoIcon() {
    return react_1.default.createElement(BaseIcon, {
        //color: '#2E9AFE'
        color: "white",
    }, react_1.default.createElement("circle", { cx: "12", cy: "12", r: "10" }), react_1.default.createElement("line", { x1: "12", y1: "16", x2: "12", y2: "12" }), react_1.default.createElement("line", { x1: "12", y1: "8", x2: "12", y2: "8" }));
}; //alert.info
var SuccessIcon = function SuccessIcon() {
    return react_1.default.createElement(BaseIcon, {
        //color: '#31B404' //초록
        color: "white",
    }, react_1.default.createElement("path", { d: "M22 11.08V12a10 10 0 1 1-5.93-9.14" }), react_1.default.createElement("polyline", { points: "22 4 12 14.01 9 11.01" }));
}; //alert.success
var ErrorIcon = function ErrorIcon() {
    return react_1.default.createElement(BaseIcon, { color: "#FF0040" }, react_1.default.createElement("circle", { cx: "12", cy: "12", r: "10" }), react_1.default.createElement("line", { x1: "12", y1: "8", x2: "12", y2: "12" }), react_1.default.createElement("line", { x1: "12", y1: "16", x2: "12", y2: "16" }));
}; //alert.error
var CloseIcon = function CloseIcon() {
    return react_1.default.createElement(BaseIcon, { color: "#FFFFFF", pushRight: false }, react_1.default.createElement("line", { x1: "18", y1: "6", x2: "6", y2: "18" }), react_1.default.createElement("line", { x1: "6", y1: "6", x2: "18", y2: "18" }));
};
var _extends = Object.assign ||
    function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
var alertStyle = {
    backgroundColor: "#7367f0",
    color: "white",
    padding: "10px",
    textTransform: "uppercase",
    borderRadius: "3px",
    display: "flex",
    justifyContent: "space-between",
    alignItems: "center",
    boxShadow: "0px 2px 2px 2px rgba(0, 0, 0, 0.03)",
    fontFamily: "Arial",
    width: "350px",
    maxWidth: "95vw",
    boxSizing: "border-box",
};
var buttonStyle = {
    marginLeft: "20px",
    border: "none",
    backgroundColor: "transparent",
    cursor: "pointer",
    color: "#FFFFFF",
    outline: "none",
};
var breakLine = function (text) {
    if (text) {
        text = text + "";
        var arr = text.split("\n");
        var data = [];
        for (var i = 0; i < arr.length; i++) {
            data.push(arr[i]);
            if (i + 1 !== arr.length) {
                data.push(react_1.default.createElement("br", {
                    key: "alertbr" + i,
                }));
            }
        }
        return data;
    }
    else {
        return "오류";
    }
    /*
    var br = React.createElement('br');
    var regex = /(<br \/>)/g;
    return text.split(regex).map(function(line, index) {
        return line.match(regex) ? <br key={"key_" + index} /> : line;
    });
    */
};
var AlertTemplate = function AlertTemplate(_ref) {
    var message = _ref.message, options = _ref.options, style = _ref.style, close = _ref.close;
    //console.log(message);
    //  console.log(breakLine(message));
    return react_1.default.createElement("div", {
        style: _extends({}, alertStyle, style),
        className: "no-drag",
    }, options.type === "info" && react_1.default.createElement(InfoIcon, null), options.type === "success" && react_1.default.createElement(SuccessIcon, null), options.type === "error" && react_1.default.createElement(ErrorIcon, null), react_1.default.createElement("span", {
        style: { flex: 2, cursor: "default" },
    }, breakLine(message)), react_1.default.createElement("button", { onClick: close, style: buttonStyle, className: "alertClose" }, react_1.default.createElement(CloseIcon, null)));
};
exports.default = AlertTemplate;
